//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8  // number of lines that will draw
#property strict
#include <stdlib.mqh>
//
string IndicatorName = "Smoothed_Stoch";
//
enum           ENUM_INDI_BUFFERS  { LEV_UP,      LEV_MI,     LEV_DN,       DSS_BUFF,    DSS_UA,      DSS_UB,      DSS_DA,      DSS_DB,      SLOPE, endIndiBuffs};
string              indiLabels[] ={"LEV_UP",     "LEV_MI",   "LEV_DN",     "DSS_BUFF",  "DSS_UA",    "DSS_UB",    "DSS_DA",    "DSS_DB",    "SLOPE"};
color               indiColors[] ={clrLimeGreen, clrDimGray, clrOrangeRed, clrSilver,   C'0,187,0',  C'0,187,0',  C'255,0,0',  C'255,0,0',  clrNONE};
int                 indiWidths[] ={1,            1,          1,            2,           2,           2,           2,           2,           1};
ENUM_LINE_STYLE indiDrawStyles[] ={STYLE_DOT,    STYLE_DOT,  STYLE_DOT,    STYLE_SOLID, STYLE_SOLID, STYLE_SOLID, STYLE_SOLID, STYLE_SOLID, STYLE_SOLID};
int              indiDrawShape[] ={DRAW_LINE,    DRAW_LINE,  DRAW_LINE,    DRAW_LINE,   DRAW_LINE,   DRAW_LINE,   DRAW_LINE,   DRAW_LINE,   DRAW_NONE}; 
//
struct st_indiBuffs
 {
   double indiBuff[];
 } indiBuffs[endIndiBuffs];
//
enum enPrices
 {
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
 };
enum enColorOn
 {
   cl_slope, // Change color on slope change
   cl_mid,   // Change color on middle level cross
   cl_out    // Change color on outer levels cross
 };
extern long     UniqueID         = 932;        // Unique ID for the Indicator
extern double   TopLevel         = 70;         // High Trade Level
extern double   BottomLevel      = 30;         // low Trade Level
extern enPrices Price            = pr_close;   // Price to use 
extern int      StochasticDepth  = 1;          // Depth
extern int      StochasticLength = 55;         // Period
input ENUM_TIMEFRAMES   MAPeriod = PERIOD_M5;  // Smoothing period 
input ENUM_MA_METHOD MAMethod    = MODE_EMA;   // Smoothing method
input enColorOn ColorOn          = cl_out;     // Color change on
extern int      FlLookBack       = 25;         // Floating levels look back period
extern double   FlLevelUp        = 90;         // Floating levels up level %
extern double   FlLevelDown      = 10;         // Floating levels down level %
extern bool     alertsOn         = false;      // Turn alerts on
extern bool     alertsOnCurrent  = true;       // Alerts on current
extern bool     alertsMessage    = true;       // Alerts message
extern bool     alertsSound      = false;      // Alerts sound
extern bool     alertsEmail      = false;      // Alerts email
//-------- Work Variables ------
double   topLevel;          // High Trade Level
double   bottomLevel;       // low Trade Level
enPrices lPrice;            // Price to use 
int      stochasticDepth;   // Depth
int      stochasticLength;  // Period
ENUM_TIMEFRAMES mAPeriod;   // Smoothing period 
ENUM_MA_METHOD  mAMethod;   // Smoothing method
enColorOn colorOn;          // Color change on :  
int       flLookBack;       // Floating levels look back period
double    flLevelUp;        // Floating levels up level %
double    flLevelDown;      // Floating levels down level %
//
enum ENUM_OBJ_IDX   {TOP_LEVEL,   BOTTOM_LEVEL,   PRICE,   DEPTH,   LENGTH,   PERIOD,   MA_METHOD,   CLR_CHANGE,   LOOK_BACK,   LEVEL_UP,   LEVEL_DN, endObjIdx};
string lblNames[] = {"TOP_LEVEL", "BOTTOM_LEVEL", "PRICE", "DEPTH", "LENGTH", "PERIOD", "MA_METHOD", "CLR_CHANGE", "LOOK_BACK", "LEVEL_UP", "LEVEL_DN"};
string boxNames[] = {"TOP_LEVEL", "BOTTOM_LEVEL", "PRICE", "DEPTH", "LENGTH", "PERIOD", "MA_METHOD", "CLR_CHANGE", "LOOK_BACK", "LEVEL_UP", "LEVEL_DN"};
color  boxBkgrnd[]= {clrWhite,    clrWhite,       clrGray, clrWhite,clrWhite, clrGray,  clrGray,     clrGray,      clrWhite,    clrWhite,   clrWhite};
bool   boxNoWrite[]={false,       false,          true,    false,   false,    true,     true,        true,         false,       false,      false};
double boxValue[endObjIdx];
string boxGlobalVarName[endObjIdx];
string lblPromt[endObjIdx];
int ySpace=15,  yOffset=10;
int xOffset=10, xBoxOffset=170;
//
#define MAX_DEPTH 15           // const int MAX_DEPTH = 15;
#define DSS_INSTANCE_SIZE 3    // const int DSS_INSTANCE_SIZE = 3;
const int INDI_MAX = 105, INDI_MIN = -5;
bool drawRequested = false, busyMutex = false;
//+------------------------------------------------------------------+
//| Indicator initialization function                                |
//+------------------------------------------------------------------+
int OnInit()
 {
   int initSucceeded = INIT_SUCCEEDED;
   IndicatorName += IntegerToString(UniqueID);
   IndicatorShortName(IndicatorName);
   if(Bars<stochasticLength)
    {
      initSucceeded = INIT_FAILED;
      Print(__FUNCTION__," Not Enough History, ",IntegerToString(stochasticLength)," bars required, ",IntegerToString(Bars)," found.");
    }
   // Set up the display
   for(ENUM_OBJ_IDX i=0; i < endObjIdx; i++)  // ensure object names unique to this Indicator instance
    {
      lblNames[i] = IntegerToString(UniqueID)+"_"+lblNames[i]+"_LBL";
      boxNames[i] = IntegerToString(UniqueID)+"_"+boxNames[i]+"_BOX";
    }
   for(ENUM_OBJ_IDX i=0; i < endObjIdx; i++)   // Make Global variable Names for global variable value storage
    {
      boxGlobalVarName[i] = boxNames[i];   // Any reason to do anything else?  Can't think of one, meaning haveing boxGlobalVarName is not necessary.
      loadBoxValue(boxGlobalVarName[i], i);
      moveBoxTextToWorkVar( i );
    }
   stochasticLength = MathMax(1,stochasticLength);
   stochasticDepth  = MathMax(MathMin(stochasticDepth,MAX_DEPTH),1);
   //
   IndicatorSetDouble(INDICATOR_MINIMUM,INDI_MIN);
   IndicatorSetDouble(INDICATOR_MAXIMUM,INDI_MAX);
   IndicatorBuffers(endIndiBuffs);
   for(ENUM_INDI_BUFFERS i=0; i < endIndiBuffs; i++)
    {
      SetIndexBuffer(i, indiBuffs[i].indiBuff );
      SetIndexStyle( i, indiDrawShape[i],indiDrawStyles[i], indiWidths[i], indiColors[i] );
      SetIndexLabel( i, indiLabels[i] );
      SetIndexEmptyValue(i,EMPTY_VALUE);
    }
   //
   EventSetTimer(1);
   //
   return(INIT_SUCCEEDED);
 }
//+------------------------------------------------------------------+
//| Exit Function                                                    |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
 {
    EventKillTimer();
    for(ENUM_OBJ_IDX i=0; i < endObjIdx; i++)
     {
      ObjectDelete(lblNames[i]);
      ObjectDelete(boxNames[i]);
     }
    Comment("");
 }
//+------------------------------------------------------------------+
//| Timer Function                                                   |
//+------------------------------------------------------------------+
void OnTimer(void)
 {
   if( (drawRequested==true) && (busyMutex==false) )
    {
      busyMutex = true;
      int limit = Bars-2; // DSS_BUFF,    DSS_UA,      DSS_UB,      DSS_DA,      DSS_DB,
      ArrayInitialize(indiBuffs[DSS_BUFF].indiBuff,EMPTY_VALUE); ArrayInitialize(indiBuffs[DSS_UA].indiBuff,EMPTY_VALUE); ArrayInitialize(indiBuffs[DSS_UB].indiBuff,EMPTY_VALUE);
      ArrayInitialize(indiBuffs[DSS_DA].indiBuff,EMPTY_VALUE); ArrayInitialize(indiBuffs[DSS_DB].indiBuff,EMPTY_VALUE);
      runTheIndicator(limit);
      drawRequested = false;
    }
   else if(drawRequested==true)
    {
      string mutexString = __FUNCTION__+" experienced a Busy Mutex.";
      Comment(mutexString); Print(mutexString);
    }
 }
//+------------------------------------------------------------------+
//|   On Chart Event                                                 |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,  const long &lparam, const double &dparam,  const string &sparam)
 {
   if( id == CHARTEVENT_OBJECT_CLICK)
    {
      static string compareStr = IntegerToString(UniqueID);
      static int compareLen    = StringLen(compareStr);
      if( StringCompare(StringSubstr(sparam,0,compareLen),compareStr) == 0 )   // Click on oject belonging to this indicator
       {
         processObjectClicks(sparam);
       }
    }
   if( id == CHARTEVENT_OBJECT_ENDEDIT )
    {
      static string compareStr = IntegerToString(UniqueID);
      static int compareLen    = StringLen(compareStr);
      if( StringCompare(StringSubstr(sparam,0,compareLen),compareStr) == 0 )   // Click on oject belonging to this indicator
       {
         processEditObject(sparam);
       }
    }
 }
//+------------------------------------------------------------------+
//| Quote Event Function                                             |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &time[], const double &open[], const double &high[], 
                const double &low[], const double &close[], const long &tick_volume[], const long &volume[], const int &spread[])
 {
   int limit = MathMin(rates_total-(prev_calculated-1),rates_total-1);
   if( prev_calculated < 1 )  // First Time through
    {
      makeObjDisplay();
    }
   //
   if(busyMutex==false)
    {
      runTheIndicator(limit);
    }
   else
    {
      string mutexString = __FUNCTION__+" experienced a Busy Mutex.";
      Comment(mutexString); Print(mutexString);
    }
   runTheAlerts();
   //
   return( rates_total);
 }
void runTheIndicator(const int& limit)
 {
   busyMutex=true;
   if (indiBuffs[SLOPE].indiBuff[limit]==-1) CleanPoint(limit,indiBuffs[DSS_DA].indiBuff,indiBuffs[DSS_DB].indiBuff);
   else if (indiBuffs[SLOPE].indiBuff[limit]== 1) CleanPoint(limit,indiBuffs[DSS_UA].indiBuff,indiBuffs[DSS_UB].indiBuff);
 	for(int i = limit; i>=0; i--)
 	 {
 	   double price = getPrice(lPrice,Open,Close,High,Low,i);
 	   //
      indiBuffs[DSS_BUFF].indiBuff[i] = iDss(price,price,price,stochasticLength,mAPeriod,mAMethod,i,Bars,0);  // why same value 3 times?
      for (int k=1; k<stochasticDepth; k++)
       {
         double dssBuffValue = indiBuffs[DSS_BUFF].indiBuff[i];
         indiBuffs[DSS_BUFF].indiBuff[i] = iDss(dssBuffValue,dssBuffValue,dssBuffValue,stochasticLength,mAPeriod,mAMethod,i,Bars,k);   // why same value 3 times?
       }
      indiBuffs[DSS_DA].indiBuff[i] = EMPTY_VALUE;
 	   indiBuffs[DSS_DB].indiBuff[i] = EMPTY_VALUE;
      double min   = indiBuffs[DSS_BUFF].indiBuff[ArrayMinimum(indiBuffs[DSS_BUFF].indiBuff, flLookBack, i)];
      double max   = indiBuffs[DSS_BUFF].indiBuff[ArrayMaximum(indiBuffs[DSS_BUFF].indiBuff, flLookBack, i)];
      double range = max-min;
      indiBuffs[LEV_UP].indiBuff[i] = min+flLevelUp*range/100.0;
      indiBuffs[LEV_DN].indiBuff[i] = min+flLevelDown*range/100.0;
      indiBuffs[LEV_MI].indiBuff[i] = min+0.5*range;
      indiBuffs[SLOPE].indiBuff[i]  = (i<Bars-1) ? indiBuffs[SLOPE].indiBuff[i+1] : 0;
      setSlope( ColorOn, i );
    }
   busyMutex=false;
 }
//
void setSlope(const enColorOn& lcolorOn, const int& workBar )
 {
   switch (lcolorOn)
    {
      case cl_mid:
         if (indiBuffs[DSS_BUFF].indiBuff[workBar]>indiBuffs[LEV_MI].indiBuff[workBar]) indiBuffs[SLOPE].indiBuff[workBar] =  1;
         if (indiBuffs[DSS_BUFF].indiBuff[workBar]<indiBuffs[LEV_MI].indiBuff[workBar]) indiBuffs[SLOPE].indiBuff[workBar] = -1;
         break;
      case cl_out:
         indiBuffs[SLOPE].indiBuff[workBar] = 0;
         if (indiBuffs[DSS_BUFF].indiBuff[workBar]>indiBuffs[LEV_UP].indiBuff[workBar]) indiBuffs[SLOPE].indiBuff[workBar] =  1;  
         if (indiBuffs[DSS_BUFF].indiBuff[workBar]<indiBuffs[LEV_DN].indiBuff[workBar]) indiBuffs[SLOPE].indiBuff[workBar] = -1;  
         break;
      default :
         if (workBar<Bars-1)
         {
            if (indiBuffs[DSS_BUFF].indiBuff[workBar]>indiBuffs[DSS_BUFF].indiBuff[workBar+1]) indiBuffs[SLOPE].indiBuff[workBar] =  1;  
            if (indiBuffs[DSS_BUFF].indiBuff[workBar]<indiBuffs[DSS_BUFF].indiBuff[workBar+1]) indiBuffs[SLOPE].indiBuff[workBar] = -1;  
         }                  
    }
   if (indiBuffs[SLOPE].indiBuff[workBar]==-1)
      PlotPoint(workBar, indiBuffs[DSS_DA].indiBuff, indiBuffs[DSS_DB].indiBuff, indiBuffs[DSS_BUFF].indiBuff);
   if (indiBuffs[SLOPE].indiBuff[workBar]== 1)
      PlotPoint(workBar, indiBuffs[DSS_UA].indiBuff, indiBuffs[DSS_UB].indiBuff, indiBuffs[DSS_BUFF].indiBuff);
 }
//
void runTheAlerts(void)
 {
   if (alertsOn)
    {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (indiBuffs[SLOPE].indiBuff[whichBar] != indiBuffs[SLOPE].indiBuff[whichBar+1])
       {
         if (indiBuffs[SLOPE].indiBuff[whichBar] == 1) doAlert((string)stochasticDepth+" times smoothed dss state changed to up");
         if (indiBuffs[SLOPE].indiBuff[whichBar] ==-1) doAlert((string)stochasticDepth+" times dss state changed to down");
       }         
    }
 }
//
void doAlert(const string doWhat)
 {
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   //
   if (previousAlert != doWhat || previousTime != Time[0])
    {
       previousAlert  = doWhat;
       previousTime   = Time[0];
       message = _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
       if (alertsMessage) Alert(message);
       if (alertsEmail)   SendMail(_Symbol+" Recursive smoothed stochastic",message);
       if (alertsSound)   PlaySound("alert2.wav");
    }
 }
//------------------------------------------------------------------
//
//------------------------------------------------------------------
double iDss(const double& close, const double& high, const double& low, const int& length, const ENUM_TIMEFRAMES& smooth, const ENUM_MA_METHOD& mode, int i, const int& bars, int instanceNo=0)
{
   static const int _sst = 0, _pHigh=1, _pLow=2;
   static double   workDss[1][MAX_DEPTH*DSS_INSTANCE_SIZE];  // MAX_DEPTH*DSS_INSTANCE_SIZE
   if (ArrayRange(workDss,0)!=bars)
    {
      ArrayResize(workDss,bars);
    }
   // Comment("workDSS Range: ",IntegerToString(ArrayRange(workDss,0)),", workDSS Size: ",IntegerToString(ArraySize(workDss),", bars: ",IntegerToString(bars),", Bars: ",IntegerToString(Bars));
   int maInstance = instanceNo*2, r=i; i=Bars-i-1; instanceNo*=DSS_INSTANCE_SIZE;
   workDss[i][instanceNo+_pHigh] = high;
   workDss[i][instanceNo+_pLow]  = low;
   // 
   double min = workDss[i][instanceNo+_pLow];
   double max = workDss[i][instanceNo+_pHigh];
   for (int k=1; k<length && (i-k)>=0; k++)
   {
      min = MathMin(min,workDss[i-k][instanceNo+_pLow]);
      max = MathMax(max,workDss[i-k][instanceNo+_pHigh]);
   }
   double stoch  = (min!=max) ? 100*(close-min)/(max-min) : 0;
   workDss[i][instanceNo+_sst] = iCustomMa(mode,stoch,smooth,r,bars,maInstance+0);
   //
   min = workDss[i][instanceNo+_sst];
   max = workDss[i][instanceNo+_sst];
   for (int k=1; k<length && (i-k)>=0; k++)
   {
      min = MathMin(min,workDss[i-k][instanceNo+_sst]);
      max = MathMax(max,workDss[i-k][instanceNo+_sst]);
   }
   stoch = (min!=max) ? 100*(workDss[i][instanceNo+_sst]-min)/(max-min) : 0;
   return(iCustomMa(mode,stoch,smooth,r,bars,maInstance+1));
 }
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
double iCustomMa(const ENUM_MA_METHOD& mode, const double& price, const ENUM_TIMEFRAMES& length, int r, const int& bars, const int instanceNo=0)
 {
   r = Bars-r-1;
   switch (mode)
    {
      case MODE_SMA   : return(iSma(price,(int)length,r,bars,instanceNo));
      case MODE_EMA   : return(iEma(price,length,r,bars,instanceNo));
      case MODE_SMMA  : return(iSmma(price,(int)length,r,bars,instanceNo));
      case MODE_LWMA  : return(iLwma(price,(int)length,r,bars,instanceNo));
      default         : return(price);
    }
 }
//
double iSma(double price, int period, int r, int _bars, int instanceNo=0)
 {
   static double workSma[1][DSS_INSTANCE_SIZE*MAX_DEPTH*2];
   //
   if (ArrayRange(workSma,0)!= _bars) ArrayResize(workSma,_bars); int k=1;

   workSma[r][instanceNo+0] = price;
   double avg = price;
   for(; k<period && (r-k)>=0; k++)
      avg += workSma[r-k][instanceNo+0];
   avg /= (double)k;
   return(avg);
 }
//
double iEma(double price, double period, int r, int _bars, int instanceNo=0)
{
   static double workEma[1][DSS_INSTANCE_SIZE*MAX_DEPTH*2];
   if (ArrayRange(workEma,0)!= _bars) ArrayResize(workEma,_bars);
   //
   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}
//
double iSmma(double price, double period, int r, int _bars, int instanceNo=0)
{
   static double workSmma[1][DSS_INSTANCE_SIZE*MAX_DEPTH*2];
   if (ArrayRange(workSmma,0)!= _bars) ArrayResize(workSmma,_bars);
   //
   workSmma[r][instanceNo] = price;
   if (r>1 && period>1)
          workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}
//
double iLwma(double price, double period, int r, int _bars, int instanceNo=0)
 {
   static double workLwma[1][DSS_INSTANCE_SIZE*MAX_DEPTH*2];
   if (ArrayRange(workLwma,0)!= _bars)
      ArrayResize(workLwma,_bars);
   //
   workLwma[r][instanceNo] = price;
   if (period<1)
      return(price);
   double sumw = period;
   double sum  = period*price;
   //
   for(int k=1; k<period && (r-k)>=0; k++)
    {
      double weight = period-k;
             sumw  += weight;
             sum   += weight*workLwma[r-k][instanceNo];  
    }             
   return(sum/sumw);
 }
//------------------------------------------------------------------
//
//------------------------------------------------------------------
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
 {
   static double workHa[1][4];
   if (tprice>=pr_haclose)
    {
      if (ArrayRange(workHa,0)!= Bars)
         ArrayResize(workHa,Bars);
      instanceNo*=4;
      int r = Bars-i-1;
      double haOpen;
      //
      if (r>0)
             haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
      else   haOpen  = (open[i]+close[i])/2;
      double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
      double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
      double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));
      //
      if(haOpen  <haClose)
       {
         workHa[r][instanceNo+0] = haLow;
         workHa[r][instanceNo+1] = haHigh;
       } 
      else
       {
         workHa[r][instanceNo+0] = haHigh;
         workHa[r][instanceNo+1] = haLow;
       }
      workHa[r][instanceNo+2] = haOpen;
      workHa[r][instanceNo+3] = haClose;
      //
      switch (tprice)
       {
         case pr_haclose:     return(haClose);
         case pr_haopen:      return(haOpen);
         case pr_hahigh:      return(haHigh);
         case pr_halow:       return(haLow);
         case pr_hamedian:    return((haHigh+haLow)/2.0);
         case pr_hamedianb:   return((haOpen+haClose)/2.0);
         case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
         case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
         case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
         case pr_hatbiased:
            if (haClose>haOpen)
               return((haHigh+haClose)/2.0);
            else
               return((haLow+haClose)/2.0);        
         case pr_hatbiased2:
            if (haClose>haOpen)
               return(haHigh);
            if (haClose<haOpen)
               return(haLow);
            return(haClose);        
       }
    }
   //
   switch (tprice)
    {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
    }
   return(0);
 }   
//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
void CleanPoint(int i,double& first[],double& second[])
 {
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
 } 
void PlotPoint(int i,double& first[],double& second[],double& from[])
 {
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
       {
         first[i]  = from[i];
         first[i+1]  = from[i+1];
         second[i] = EMPTY_VALUE;
       }
      else
       {
         second[i] =  from[i];
         second[i+1] = from[i+1];
         first[i]  = EMPTY_VALUE;
       }
   else
    {
      first[i]  = from[i];
      second[i] = EMPTY_VALUE;
    }
 }
//-------------------------------------------------------------------
//  On Display Control Functions
//-------------------------------------------------------------------
void loadBoxValue( const string& varName, const ENUM_OBJ_IDX& varID )
 {
   if( GlobalVariableCheck(varName) ) // A value has been stored
    {
      boxValue[varID] = GlobalVariableGet(varName);
    }
   else
    {
      boxValue[varID] = getBoxDefault( varName, varID );
    }
 }
double getBoxDefault( const string& varName, const ENUM_OBJ_IDX& varID )
 {
   double defaultVal=0;
   switch (varID)
    {
      case TOP_LEVEL:      defaultVal = TopLevel;         break;
      case BOTTOM_LEVEL:   defaultVal = BottomLevel;      break;
      case PRICE:          defaultVal = Price;            break;
      case DEPTH:          defaultVal = StochasticDepth;  break;
      case LENGTH:         defaultVal = StochasticLength; break;
      case PERIOD:         defaultVal = MAPeriod;         break;
      case MA_METHOD:      defaultVal = MAMethod;         break;
      case CLR_CHANGE:     defaultVal = ColorOn;          break;
      case LOOK_BACK:      defaultVal = FlLookBack;       break;
      case LEVEL_UP:       defaultVal = FlLevelUp;        break;
      case LEVEL_DN:       defaultVal = FlLevelDown;      break;
      default:
         {
            string badMsg = __FUNCTION__+" called with invalid value: "+IntegerToString(varID);
            Comment(badMsg); Print(badMsg);
         }
         break;
    }
   return( defaultVal );
 }
void moveBoxTextToWorkVar( const ENUM_OBJ_IDX& varID )
 {
   switch (varID)
    {
      case TOP_LEVEL:      topLevel         = boxValue[varID];             break;
      case BOTTOM_LEVEL:   bottomLevel      = boxValue[varID];             break;
      case PRICE:          lPrice           = (enPrices) boxValue[varID];  break;
      case DEPTH:          stochasticDepth  = (int) boxValue[varID];       break;
      case LENGTH:         stochasticLength = (int) boxValue[varID];             break;
      case PERIOD:         mAPeriod         = (ENUM_TIMEFRAMES) boxValue[varID]; break;
      case MA_METHOD:      mAMethod         = (ENUM_MA_METHOD) boxValue[varID];  break;
      case CLR_CHANGE:     colorOn          = (enColorOn) boxValue[varID];       break;
      case LOOK_BACK:      flLookBack       = (int) boxValue[varID];             break;
      case LEVEL_UP:       flLevelUp        = boxValue[varID];                   break;
      case LEVEL_DN:       flLevelDown      = boxValue[varID];                   break;
      default:
         {
            string badMsg = __FUNCTION__+" called with invalid value: "+IntegerToString(varID);
            Comment(badMsg); Print(badMsg);
         }
         break;
    }
 }
//
void setGlobalVarValue( const string& varName, const double& varVal )
 {
   if(GlobalVariableSet( varName, varVal) < 1) // returns zero on failuire
    {
      string badMsg = __FUNCTION__+" failed, error: "+IntegerToString(GetLastError())+", "+ErrorDescription(GetLastError());
      Comment(badMsg); Print(badMsg);
    }
 }
double getBoxDisplayValue( const ENUM_OBJ_IDX varID )
 {
   double newValue = StringToDouble(ObjectGetString(ChartID(),boxGlobalVarName[varID],OBJPROP_TEXT,0));
   return(newValue); 
 }
void makeObjDisplay(void)  // Put all the display objects on the screen
 {
    for(ENUM_OBJ_IDX i=0; i < endObjIdx; i++)   // Make Global variable Names for global variable value storage
     {
      displayLabel(i);   // Any reason to do anything else?  Can't think of one, meaning haveing boxGlobalVarName is not necessary.
      displayBox(i);
     }
    SetLevelValue( 0, topLevel );
    SetLevelValue( 1, bottomLevel );
 }
void displayLabel( const ENUM_OBJ_IDX varID )
 {
   switch (varID)
    {
      case TOP_LEVEL:      manageLabel(lblNames[varID], "Top Line (70):",    xOffset, yOffset + (varID*ySpace) );  break;
      case BOTTOM_LEVEL:   manageLabel(lblNames[varID], "Bottom Line (30):", xOffset, yOffset + (varID*ySpace) );  break;
      case PRICE:          manageLabel(lblNames[varID], "Price (close): " + getPriceDesc (lPrice), xOffset, yOffset + (varID*ySpace) );  break;
      case DEPTH:          manageLabel(lblNames[varID], "Depth (1):",        xOffset, yOffset + (varID*ySpace) );  break;
      case LENGTH:         manageLabel(lblNames[varID], "Stoch Length {55}:",xOffset, yOffset + (varID*ySpace) );  break;
      case PERIOD:         manageLabel(lblNames[varID], "MA (M5): " + getTFDesc(mAPeriod), xOffset, yOffset + (varID*ySpace) );  break;
      case MA_METHOD:      manageLabel(lblNames[varID], "Method (EMA): " + getMADesc (mAMethod), xOffset, yOffset + (varID*ySpace) );  break;
      case CLR_CHANGE:     manageLabel(lblNames[varID], "Clr Change (out): "+ getChangeDesc (colorOn), xOffset, yOffset + (varID*ySpace) );  break;
      case LOOK_BACK:      manageLabel(lblNames[varID], "Look Back (25):",   xOffset, yOffset + (varID*ySpace) );  break;
      case LEVEL_UP:       manageLabel(lblNames[varID], "Level Up (90):",    xOffset, yOffset + (varID*ySpace) );  break;
      case LEVEL_DN:       manageLabel(lblNames[varID], "Level Down {10}:",  xOffset, yOffset + (varID*ySpace) );  break;
      default:
         {
            string badMsg = __FUNCTION__+" called with invalid value: "+IntegerToString(varID);
            Comment(badMsg); Print(badMsg);
         }
         break;
    }
 }
void displayBox( const ENUM_OBJ_IDX varID )
 { static int cntr = 4;
   switch (varID)
    {  // doing everythign exactly the same, don't really need the switch
      case TOP_LEVEL:      manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case BOTTOM_LEVEL:   manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case PRICE:          manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case DEPTH:          manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case LENGTH:         manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case PERIOD:         manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case MA_METHOD:      manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case CLR_CHANGE:     manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case LOOK_BACK:      manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case LEVEL_UP:       manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      case LEVEL_DN:       manageEditBox(boxNames[varID], DoubleToStr(boxValue[varID],0), xBoxOffset, yOffset + cntr + (varID*ySpace), varID );  break;
      default:
         {
            string badMsg = __FUNCTION__+" called with invalid value: "+IntegerToString(varID);
            Comment(badMsg); Print(badMsg);
         }
         break;
    }
 }
//+------------------------------------------------------------------+
void manageLabel(const string& objName, const string dispText, const int& xPos, const int yPos)
 {
   static long chartID = ChartID();
   int windowNum = WindowFind(IndicatorName);
   if ( ObjectFind(chartID,objName) < 0 )
    {
      ObjectCreate(chartID,objName,OBJ_LABEL,             windowNum, 0, 0);
      ObjectSetInteger(chartID,objName,OBJPROP_FONTSIZE,  11);
      ObjectSetString (chartID,objName,OBJPROP_FONT,      "Calibri");
      ObjectSetInteger(chartID,objName,OBJPROP_COLOR,     clrOrangeRed);
      ObjectSetInteger(chartID,objName,OBJPROP_CORNER,    CORNER_LEFT_UPPER);
      ObjectSetInteger(chartID,objName,OBJPROP_ANCHOR,    ANCHOR_LEFT_UPPER);
      ObjectSetInteger(chartID,objName,OBJPROP_BACK,      true);
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTABLE,false);
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTED,  false);
      ObjectSetInteger(chartID,objName,OBJPROP_HIDDEN,    true);
    }
   ObjectSetInteger(chartID,objName,OBJPROP_XDISTANCE,    xPos );
   ObjectSetInteger(chartID,objName,OBJPROP_YDISTANCE,    yPos );
   ObjectSetString (chartID,objName,OBJPROP_TEXT,         dispText );
}
//+------------------------------------------------------------------+
void manageEditBox(const string& objName, const string dispText, const int& xPos, const int yPos,const ENUM_OBJ_IDX idx )
 {
   static long chart_ID = ChartID();
   int windowNum = WindowFind(IndicatorName);
   if( ObjectFind(chart_ID, objName)<0 )
    {
      ObjectCreate    (chart_ID,objName,OBJ_EDIT,            windowNum, 0, 0);
      ObjectSetInteger(chart_ID,objName,OBJPROP_FONTSIZE,    11);
      ObjectSetString (chart_ID,objName,OBJPROP_FONT,        "Calibri");
      ObjectSetInteger(chart_ID,objName,OBJPROP_XSIZE,       50);
      ObjectSetInteger(chart_ID,objName,OBJPROP_YSIZE,       18);
      ObjectSetInteger(chart_ID,objName,OBJPROP_ALIGN,       ALIGN_CENTER);
      ObjectSetInteger(chart_ID,objName,OBJPROP_READONLY,    boxNoWrite[idx]);
      ObjectSetInteger(chart_ID,objName,OBJPROP_CORNER,      CORNER_LEFT_UPPER);
      ObjectSetInteger(chart_ID,objName,OBJPROP_BGCOLOR,     boxBkgrnd[idx]);
      ObjectSetInteger(chart_ID,objName,OBJPROP_COLOR,       clrBlack);
      ObjectSetInteger(chart_ID,objName,OBJPROP_BORDER_COLOR,clrBlack);
      ObjectSetInteger(chart_ID,objName,OBJPROP_BACK,        false);
      ObjectSetInteger(chart_ID,objName,OBJPROP_SELECTABLE,  false);
      ObjectSetInteger(chart_ID,objName,OBJPROP_SELECTED,    false);
      ObjectSetInteger(chart_ID,objName,OBJPROP_HIDDEN,      true);
    }
   ObjectSetInteger(chart_ID,objName,OBJPROP_XDISTANCE,      xPos);
   ObjectSetInteger(chart_ID,objName,OBJPROP_YDISTANCE,      yPos);
   ObjectSetString (chart_ID,objName,OBJPROP_TEXT,           dispText);
 }
//+------------------------------------------------------------------+
//|  Process On Chart Events
//+------------------------------------------------------------------+
void processObjectClicks(const string& sparam)
 { // enum ENUM_OBJ_IDX   {TOP_LEVEL,   BOTTOM_LEVEL,   PRICE,   DEPTH,   LENGTH,   PERIOD,   MA_METHOD,   CLR_CHANGE,   LOOK_BACK,   LEVEL_UP,   LEVEL_DN, endObjIdx};
   if( sparam == lblNames[PRICE] )
    {
      if( lPrice < pr_hatbiased2 )
       {
         lPrice++;
       }
      else
       {
         lPrice = 0;
       }
      boxValue[PRICE] = lPrice;
      setGlobalVarValue( boxGlobalVarName[PRICE],  boxValue[PRICE] );
      displayLabel( PRICE );  displayBox( PRICE );
      drawRequested = true;
    }
   else if( sparam == lblNames[PERIOD] )
    {
      mAPeriod = getNextPeriod(mAPeriod);
      boxValue[PERIOD] = mAPeriod;
      setGlobalVarValue( boxGlobalVarName[PERIOD], boxValue[PERIOD] );
      displayLabel( PERIOD );  displayBox( PERIOD);
      drawRequested = true;
    }
   else if( sparam == lblNames[MA_METHOD] )
    {
      if( mAMethod < MODE_LWMA )
       {
         mAMethod++;
       }
      else
       {
         mAMethod = 0;
       }
      boxValue[MA_METHOD] = mAMethod;
      setGlobalVarValue( boxGlobalVarName[MA_METHOD], boxValue[MA_METHOD] );
      displayLabel( MA_METHOD );  displayBox( MA_METHOD );
      drawRequested = true;
    }
   else if( sparam == lblNames[CLR_CHANGE] )
    {
      if( colorOn < cl_out )
       {
         colorOn++;
       }
      else
       {
         colorOn = 0;
       }
      boxValue[CLR_CHANGE] = colorOn;
      setGlobalVarValue( boxGlobalVarName[CLR_CHANGE], boxValue[CLR_CHANGE] );
      displayLabel( CLR_CHANGE );  displayBox( CLR_CHANGE );
      drawRequested = true;
    }
 }
void processEditObject(const string& sparam)
 { // enum ENUM_OBJ_IDX   {TOP_LEVEL,   BOTTOM_LEVEL,   PRICE,   DEPTH,   LENGTH,   PERIOD,   MA_METHOD,   CLR_CHANGE,   LOOK_BACK,   LEVEL_UP,   LEVEL_DN, endObjIdx};
   double newVal;
   if( sparam == boxNames[TOP_LEVEL] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue(TOP_LEVEL),0);
      if( (newVal < INDI_MAX) && (newVal > INDI_MIN) )
       {
         boxValue[TOP_LEVEL] = newVal; topLevel = newVal;
         SetLevelValue( 0, topLevel );
         setGlobalVarValue( boxGlobalVarName[TOP_LEVEL], boxValue[TOP_LEVEL] );
         drawRequested = true;
       }
      displayBox( TOP_LEVEL );
    }
   else if( sparam == boxNames[BOTTOM_LEVEL] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue(BOTTOM_LEVEL),0);
      if( (newVal < INDI_MAX) && (newVal > INDI_MIN) )
       {
         boxValue[BOTTOM_LEVEL] = newVal; bottomLevel = newVal;
         SetLevelValue( 1, bottomLevel );
         setGlobalVarValue( boxGlobalVarName[BOTTOM_LEVEL], boxValue[BOTTOM_LEVEL] );
         drawRequested = true;
       }
      displayBox( BOTTOM_LEVEL );
    }
   else if( sparam == boxNames[DEPTH] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue(DEPTH),0);
      if( (newVal <= MAX_DEPTH) && (newVal > 0) )   // this version allows smoothing depths of up to 15
       {
         boxValue[DEPTH] = newVal; stochasticDepth = (int) newVal;
         setGlobalVarValue( boxGlobalVarName[DEPTH], boxValue[DEPTH] );
         drawRequested = true;
       }
      displayBox( DEPTH );
    }
   else if( sparam == boxNames[LENGTH] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue(LENGTH),0);
      if( (newVal < (Bars-(MAX_DEPTH+1))) && (newVal > 0) )   //
       {
         boxValue[LENGTH] = newVal; stochasticLength = (int) newVal;
         setGlobalVarValue( boxGlobalVarName[LENGTH], boxValue[LENGTH] );
         drawRequested = true;
       }
      displayBox( LENGTH );
    }
   else if( sparam == boxNames[LOOK_BACK] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue(LOOK_BACK),0);
      if( (newVal < (Bars-2) ) && (newVal > 0) )   //
       {
         boxValue[LOOK_BACK] = newVal; flLookBack = (int) newVal;
         setGlobalVarValue( boxGlobalVarName[LOOK_BACK], boxValue[LOOK_BACK] );
         drawRequested = true;
       }
      displayBox( LOOK_BACK );
    }
   else if( sparam == boxNames[LEVEL_UP] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue( LEVEL_UP),0);
      if( (newVal < 1000) && (newVal > 0) )   //
       {
         boxValue[LEVEL_UP] = newVal; flLevelUp = newVal;
         setGlobalVarValue( boxGlobalVarName[LEVEL_UP], boxValue[LEVEL_UP] );
         drawRequested = true;
       }
      displayBox( LEVEL_UP );
    }
   else if( sparam == boxNames[LEVEL_DN] )
    {
      newVal = NormalizeDouble(getBoxDisplayValue( LEVEL_DN ),0);
      if( (newVal < 1000) && (newVal > 0) )   //
       {
         boxValue[LEVEL_DN] = newVal; flLevelDown = newVal;
         setGlobalVarValue( boxGlobalVarName[LEVEL_DN], boxValue[LEVEL_DN] );
         drawRequested = true;
       }
      displayBox( LEVEL_DN );
    }
 }
//
ENUM_TIMEFRAMES getNextPeriod(ENUM_TIMEFRAMES tf)
 {
   ENUM_TIMEFRAMES nextTF;
   switch (tf)
    {
      case PERIOD_M1:   nextTF = PERIOD_M5;  break;
      case PERIOD_M5:   nextTF = PERIOD_M15; break;
      case PERIOD_M15:  nextTF = PERIOD_M30; break;
      case PERIOD_M30:  nextTF = PERIOD_H1;  break;
      case PERIOD_H1:   nextTF = PERIOD_H4;  break;
      case PERIOD_H4:   nextTF = PERIOD_D1;  break;
      case PERIOD_D1:   nextTF = PERIOD_W1;  break;
      case PERIOD_W1:   nextTF = PERIOD_MN1; break;
      case PERIOD_MN1:  nextTF = PERIOD_M1;  break;
      default: nextTF = (ENUM_TIMEFRAMES) Period();  break;
    }
   return( nextTF );
 }
string getPriceDesc (enPrices ePrices)
 {
   string priceDesc;
   switch (ePrices)
    {
      case pr_close:      priceDesc = "\"close\"";      break;
      case pr_open:       priceDesc = "\"open\"";       break;
      case pr_high:       priceDesc = "\"high\"";       break;
      case pr_median:     priceDesc = "\"median\"";     break;
      case pr_typical:    priceDesc = "\"typical\"";    break;
      case pr_weighted:   priceDesc = "\"weighted\"";   break;
      case pr_average:    priceDesc = "\"average\"";    break;
      case pr_medianb:    priceDesc = "\"medianb\"";    break;
      case pr_tbiased:    priceDesc = "\"tboased\"";    break;
      case pr_tbiased2:   priceDesc = "\"tboased2\"";   break;
      case pr_haclose:    priceDesc = "\"haclose\"";    break;
      case pr_haopen:     priceDesc = "\"haopen\"";     break;
      case pr_hahigh:     priceDesc = "\"hahigh\"";     break;
      case pr_halow:      priceDesc = "\"halow\"";      break;
      case pr_hamedian:   priceDesc = "\"hamedian\"";   break;
      case pr_hatypical:  priceDesc = "\"hatypical\"";  break;
      case pr_haweighted: priceDesc = "\"haweighted\"";  break;
      case pr_haaverage:  priceDesc = "\"haaverage\"";   break;
      case pr_hamedianb:  priceDesc = "\"hamedianb\"";  break;
      case pr_hatbiased:  priceDesc = "\"hatbiased\"";  break;
      case pr_hatbiased2: priceDesc = "\"hatbiased2\""; break;
      default: priceDesc = "Unknown";  break;
    }
   return( priceDesc );
 }
//
string getTFDesc (ENUM_TIMEFRAMES tf)
 {
   string tfDesc;
   switch (tf)
    {
      case PERIOD_M1:   tfDesc = "M1";   break;
      case PERIOD_M5:   tfDesc = "M5";   break;
      case PERIOD_M15:  tfDesc = "M15";  break;
      case PERIOD_M30:  tfDesc = "M30";  break;
      case PERIOD_H1:   tfDesc = "H1";   break;
      case PERIOD_H4:   tfDesc = "H4";   break;
      case PERIOD_D1:   tfDesc = "D1";   break;
      case PERIOD_W1:   tfDesc = "W1";   break;
      case PERIOD_MN1:  tfDesc = "MN1";  break;
      default: tfDesc = "Unknown";  break;
    }
   return( tfDesc );
 }
string getMADesc (ENUM_MA_METHOD mode)
 {
   string modeDesc;
   switch (mode)
    {
      case MODE_SMA:   modeDesc = "SMA";   break;
      case MODE_EMA:   modeDesc = "EMA";   break;
      case MODE_SMMA:  modeDesc = "SMMA";  break;
      case MODE_LWMA:  modeDesc = "LWMA";  break;
      default: modeDesc = "Unknown";  break;
    }
   return( modeDesc );
 }
string getChangeDesc ( enColorOn changeOn )
 {
   string clrChangeDesc;
   switch (changeOn)
    {
      case cl_slope: clrChangeDesc = "\"slope\""; break;
      case cl_mid:   clrChangeDesc = "\"mid\"";   break;
      case cl_out:   clrChangeDesc = "\"out\"";   break;
      default: clrChangeDesc= "Unknown";  break;
    }
   return( clrChangeDesc );
 }
//+------------------------------------------------------------------+